import { ServiceSchema } from 'moleculer';
import { SubjectRawRule, AnyMongoAbility, ExtractSubjectType, Subject, MongoQuery } from '@casl/ability';

type DefaultUser = {
    id: string;
};
type AnyRules = SubjectRawRule<any, any, any>[];
type AbilityConsumerMethods<TUser extends object = DefaultUser> = {
    abilityFor: (user: TUser) => Promise<AnyMongoAbility>;
};

declare function createCASLAbilityProvider<TUser extends object = DefaultUser, TMeta extends object = object>(rulesFor: (user: TUser) => AnyRules): Partial<ServiceSchema>;

declare function createCASLAbilityConsumer<TUser extends object = DefaultUser, TRules extends SubjectRawRule<string, ExtractSubjectType<Subject>, MongoQuery>[] = AnyRules>(service?: string): Partial<ServiceSchema & {
    methods: AbilityConsumerMethods<TUser>;
}>;

export { type AbilityConsumerMethods, type AnyRules, type DefaultUser, createCASLAbilityConsumer, createCASLAbilityProvider };
