import { createMongoAbility } from '@casl/ability';

function createCASLAbilityProvider(rulesFor) {
  return {
    actions: {
      ability: {
        handler(ctx) {
          return rulesFor(ctx.params);
        }
      }
    }
  };
}

function createCASLAbilityConsumer(service = "auth") {
  return {
    methods: {
      async abilityFor(user) {
        const rules = await this.broker.call(`${service}.ability`, user);
        return createMongoAbility(rules);
      }
    }
  };
}

export { createCASLAbilityConsumer, createCASLAbilityProvider };
